/* AMX Mod X
*	Skull5: Sniper Rifle.
*
* http://aghl.ru/forum/ - Russian Half-Life and Adrenaline Gamer Community
*
* This file is provided as is (no warranties)
*/

#pragma semicolon 1
#pragma ctrlchar '\'

#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <hl_wpnmod>


#define PLUGIN "Skull5"
#define VERSION "1.1"
#define AUTHOR "KORD_12.7"


// Weapon settings
#define WEAPON_NAME 			"weapon_skull5"
#define WEAPON_SLOT			3
#define WEAPON_POSITION			5
#define WEAPON_PRIMARY_AMMO		"556s"
#define WEAPON_PRIMARY_AMMO_MAX		24
#define WEAPON_SECONDARY_AMMO		"" // NULL
#define WEAPON_SECONDARY_AMMO_MAX	-1
#define WEAPON_MAX_CLIP			24
#define WEAPON_DEFAULT_AMMO		24
#define WEAPON_FLAGS			0
#define WEAPON_WEIGHT			10
#define WEAPON_DAMAGE			100.0

// Hud
#define WEAPON_HUD_TXT_1		"sprites/weapon_skull5.txt"
#define WEAPON_HUD_TXT_2		"sprites/weapon_skull5_scp.txt"
#define WEAPON_HUD_SPR_1		"sprites/weapon_skull5.spr"
#define WEAPON_HUD_SPR_2		"sprites/scope_skull.spr"

// Ammobox
#define AMMOBOX_CLASSNAME		"ammo_556s"

// Models
#define MODEL_WORLD			"models/w_skull5.mdl"
#define MODEL_VIEW			"models/v_skull5_mg.mdl"
#define MODEL_PLAYER			"models/p_skull5.mdl"

// Sounds
#define SOUND_FIRE			"weapons/g3sg1-1.wav"
#define SOUND_ZOOM			"weapons/sniper_zoom.wav"
#define SOUND_R1			"weapons/skull5_boltpull.wav"
#define SOUND_R2			"weapons/skull5_clipin.wav"
#define SOUND_R3			"weapons/skull5_clipout.wav"
#define SOUND_R4			"weapons/skull5_draw.wav"


// Animation
#define ANIM_EXTENSION			"gauss"

enum _:Animation
{
	ANIM_IDLE = 0,
	ANIM_FIRE1,
	ANIM_FIRE2,
	ANIM_RELOAD,
	ANIM_DRAW,
	
};

//**********************************************
//* Precache resources                         *
//**********************************************

public plugin_precache()
{
	PRECACHE_MODEL(MODEL_VIEW);
	PRECACHE_MODEL(MODEL_WORLD);
	PRECACHE_MODEL(MODEL_PLAYER);
		
	PRECACHE_SOUND(SOUND_FIRE);
	PRECACHE_SOUND(SOUND_ZOOM);
	PRECACHE_SOUND(SOUND_R1);
	PRECACHE_SOUND(SOUND_R2);
	PRECACHE_SOUND(SOUND_R3);
	PRECACHE_SOUND(SOUND_R4);
		
	PRECACHE_GENERIC(WEAPON_HUD_TXT_1);
	PRECACHE_GENERIC(WEAPON_HUD_SPR_1);
	PRECACHE_GENERIC(WEAPON_HUD_TXT_2);
	PRECACHE_GENERIC(WEAPON_HUD_SPR_2);
}

//**********************************************
//* Register weapon.                           *
//**********************************************

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	new iskull5 = wpnmod_register_weapon
	
	(
		WEAPON_NAME,
		WEAPON_SLOT,
		WEAPON_POSITION,
		WEAPON_PRIMARY_AMMO,
		WEAPON_PRIMARY_AMMO_MAX,
		WEAPON_SECONDARY_AMMO,
		WEAPON_SECONDARY_AMMO_MAX,
		WEAPON_MAX_CLIP,
		WEAPON_FLAGS,
		WEAPON_WEIGHT
	);
	
	
	wpnmod_register_weapon_forward(iskull5, Fwd_Wpn_Spawn, "skull5_Spawn");
	wpnmod_register_weapon_forward(iskull5, Fwd_Wpn_Deploy, "skull5_Deploy");
	wpnmod_register_weapon_forward(iskull5, Fwd_Wpn_Idle, "skull5_Idle");
	wpnmod_register_weapon_forward(iskull5, Fwd_Wpn_PrimaryAttack, "skull5_PrimaryAttack");
	wpnmod_register_weapon_forward(iskull5, Fwd_Wpn_SecondaryAttack, "skull5_SecondaryAttack");
	wpnmod_register_weapon_forward(iskull5, Fwd_Wpn_Reload, "skull5_Reload");
	wpnmod_register_weapon_forward(iskull5, Fwd_Wpn_Holster, "skull5_Holster");
	

}

//**********************************************
//* Weapon spawn.                              *
//**********************************************

public skull5_Spawn(const iItem)
{
	// Setting world model
	SET_MODEL(iItem, MODEL_WORLD);

	// Give a default ammo to weapon
	wpnmod_set_offset_int(iItem, Offset_iDefaultAmmo, WEAPON_DEFAULT_AMMO);
}

//**********************************************
//* Deploys the weapon.                        *
//**********************************************

public skull5_Deploy(const iItem, const iPlayer, const iClip)
{
	return wpnmod_default_deploy(iItem, MODEL_VIEW, MODEL_PLAYER, ANIM_DRAW, ANIM_EXTENSION);
}

//**********************************************
//* Called when the weapon is holster.         *
//**********************************************

public skull5_Holster(const iItem, const iPlayer)
{
	new Float: flFov;
	
	if (pev(iPlayer, pev_fov, flFov) && flFov != 0.0)
	{
		skull5_SecondaryAttack(iItem, iPlayer);
	}
	
	// Cancel any reload in progress.
	wpnmod_set_offset_int(iItem, Offset_iInReload, 0);
}

//**********************************************
//* Displays the idle animation for the weapon.*
//**********************************************

public skull5_Idle(const iItem, const iPlayer, const iClip)
{
	wpnmod_reset_empty_sound(iItem);

	if (wpnmod_get_offset_float(iItem, Offset_flTimeWeaponIdle) > 0.0)
	{
		return;
	}
	
	wpnmod_send_weapon_anim(iItem, ANIM_IDLE);
	wpnmod_set_offset_float(iItem, Offset_flTimeWeaponIdle, 1.55);
}

//**********************************************
//* The main attack of a weapon is triggered.  *
//**********************************************

public skull5_PrimaryAttack(const iItem, const iPlayer, iClip)
{
	if (pev(iPlayer, pev_waterlevel) == 3 || iClip <= 0)
	{
		wpnmod_play_empty_sound(iItem);
		wpnmod_set_offset_float(iItem, Offset_flNextPrimaryAttack, 0.15);
		return;
	}
	
	wpnmod_set_offset_int(iItem, Offset_iClip, iClip -= 1);
	wpnmod_set_offset_int(iPlayer, Offset_iWeaponVolume, LOUD_GUN_VOLUME);
	wpnmod_set_offset_int(iPlayer, Offset_iWeaponFlash, BRIGHT_GUN_FLASH);
	
	wpnmod_set_offset_float(iItem, Offset_flNextPrimaryAttack, 0.3);
	wpnmod_set_offset_float(iItem, Offset_flNextSecondaryAttack, 0.2);
	wpnmod_set_offset_float(iItem, Offset_flTimeWeaponIdle, 1.55);
	
	wpnmod_send_weapon_anim(iItem, iClip ? ANIM_FIRE1 : ANIM_FIRE2);
	wpnmod_set_player_anim(iPlayer, PLAYER_ATTACK1);
	
	wpnmod_fire_bullets
	(
		iPlayer, 
		iPlayer, 
		1, 
		Float: {0.0001, 0.0001, 0.0001}, 
		8192.0, 
		WEAPON_DAMAGE, 
		DMG_BULLET | DMG_NEVERGIB, 
		0
	);
	
	emit_sound(iPlayer, CHAN_WEAPON, SOUND_FIRE, 0.9, ATTN_NORM, 0, PITCH_NORM);
	
	set_pev(iPlayer, pev_effects, pev(iPlayer, pev_effects) | EF_MUZZLEFLASH);
	set_pev(iPlayer, pev_punchangle, Float: {-4.0, 0.0, 0.0});
}

//**********************************************
//* Secondary attack of a weapon is triggered. *
//**********************************************

public skull5_SecondaryAttack(const iItem, const iPlayer)
{
	new Float: flFov;
	
	if (pev(iPlayer, pev_fov, flFov) && flFov != 0.0)
	{
		MakeZoom(iItem, iPlayer, "weapon_skull5", 0.0);
		
	}
	else if (flFov != 20.0)
	{
		MakeZoom(iItem, iPlayer, "weapon_skull5_scp", 20.0);
	}
	
	emit_sound(iPlayer, CHAN_ITEM, SOUND_ZOOM, random_float(0.95, 1.0), ATTN_NORM, 0, PITCH_NORM);
	
	wpnmod_set_offset_float(iItem, Offset_flNextPrimaryAttack, 0.3);
	wpnmod_set_offset_float(iItem, Offset_flNextSecondaryAttack, 0.2);
}

MakeZoom(const iItem, const iPlayer, const szWeaponName[], const Float: flFov)
{
	static msgWeaponList;
	
	set_pev(iPlayer, pev_fov, flFov);
	wpnmod_set_offset_int(iPlayer, Offset_iFOV, _:flFov);
		
	if (msgWeaponList || (msgWeaponList = get_user_msgid("WeaponList")))		
	{
		message_begin(MSG_ONE, msgWeaponList, .player = iPlayer);
		write_string(szWeaponName);
		write_byte(wpnmod_get_offset_int(iItem, Offset_iPrimaryAmmoType));
		write_byte(WEAPON_PRIMARY_AMMO_MAX);
		write_byte(wpnmod_get_offset_int(iItem, Offset_iSecondaryAmmoType));
		write_byte(WEAPON_SECONDARY_AMMO_MAX);
		write_byte(WEAPON_SLOT - 1);
		write_byte(WEAPON_POSITION - 1);
		write_byte(get_user_weapon(iPlayer));
		write_byte(WEAPON_FLAGS);
		message_end();
	}
}

//**********************************************
//* Called when the weapon is reloaded.        *
//**********************************************

public skull5_Reload(const iItem, const iPlayer, const iClip, const iAmmo)
{
	if (iAmmo <= 0 || iClip >= WEAPON_MAX_CLIP)
	{
		return;
	}
	
	new Float: flFov;
	
	if (pev(iPlayer, pev_fov, flFov) && flFov != 0.0)
	{
		skull5_SecondaryAttack(iItem, iPlayer);
	}
	
	if (iAmmo <= 0 || iClip >= WEAPON_MAX_CLIP)
	{
		return;
	}

	wpnmod_default_reload(iItem, WEAPON_MAX_CLIP, ANIM_RELOAD, 2.03);
}

